# mypy-boto3-mgh

[![PyPI - mypy-boto3-mgh](https://img.shields.io/pypi/v/mypy-boto3-mgh.svg?color=blue)](https://pypi.org/project/mypy-boto3-mgh)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-mgh.svg?color=blue)](https://pypi.org/project/mypy-boto3-mgh)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-mgh](#mypy-boto3-mgh)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.MigrationHub 1.13.24](https://boto3.amazonaws.com/v1/documentation/api/1.13.24/reference/services/mgh.html#MigrationHub) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-mgh](#mypy-boto3-mgh)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `MigrationHub` service.

```bash
python -m pip install boto3-stubs[mgh]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_mgh` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_mgh import MigrationHubClient

# Now mypy can check if your code is valid.
client: MigrationHubClient = boto3.client("mgh")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: MigrationHubClient = session.client("mgh")



# Annotated paginators are included as well

import mypy_boto3_mgh.paginator as mgh_paginators

list_application_states_paginator: mgh_paginators.ListApplicationStatesPaginator = client.get_paginator("list_application_states")
list_created_artifacts_paginator: mgh_paginators.ListCreatedArtifactsPaginator = client.get_paginator("list_created_artifacts")
list_discovered_resources_paginator: mgh_paginators.ListDiscoveredResourcesPaginator = client.get_paginator("list_discovered_resources")
list_migration_tasks_paginator: mgh_paginators.ListMigrationTasksPaginator = client.get_paginator("list_migration_tasks")
list_progress_update_streams_paginator: mgh_paginators.ListProgressUpdateStreamsPaginator = client.get_paginator("list_progress_update_streams")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_mgh` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_mgh as mgh
from mypy_boto3_mgh import MigrationHubClient

# with these
from mypy_boto3 import mgh
from mypy_boto3.mgh import MigrationHubClient
```